git-bisect.shon commit bisect--helper: `check_and_set_terms` shell function in C (4fbdbd5)
   1#!/bin/sh
   2
   3USAGE='[help|start|bad|good|new|old|terms|skip|next|reset|visualize|view|replay|log|run]'
   4LONG_USAGE='git bisect help
   5        print this long help message.
   6git bisect start [--term-{old,good}=<term> --term-{new,bad}=<term>]
   7                 [--no-checkout] [<bad> [<good>...]] [--] [<pathspec>...]
   8        reset bisect state and start bisection.
   9git bisect (bad|new) [<rev>]
  10        mark <rev> a known-bad revision/
  11                a revision after change in a given property.
  12git bisect (good|old) [<rev>...]
  13        mark <rev>... known-good revisions/
  14                revisions before change in a given property.
  15git bisect terms [--term-good | --term-bad]
  16        show the terms used for old and new commits (default: bad, good)
  17git bisect skip [(<rev>|<range>)...]
  18        mark <rev>... untestable revisions.
  19git bisect next
  20        find next bisection to test and check it out.
  21git bisect reset [<commit>]
  22        finish bisection search and go back to commit.
  23git bisect (visualize|view)
  24        show bisect status in gitk.
  25git bisect replay <logfile>
  26        replay bisection log.
  27git bisect log
  28        show bisect log.
  29git bisect run <cmd>...
  30        use <cmd>... to automatically bisect.
  31
  32Please use "git help bisect" to get the full man page.'
  33
  34OPTIONS_SPEC=
  35. git-sh-setup
  36
  37_x40='[0-9a-f][0-9a-f][0-9a-f][0-9a-f][0-9a-f]'
  38_x40="$_x40$_x40$_x40$_x40$_x40$_x40$_x40$_x40"
  39TERM_BAD=bad
  40TERM_GOOD=good
  41
  42bisect_head()
  43{
  44        if test -f "$GIT_DIR/BISECT_HEAD"
  45        then
  46                echo BISECT_HEAD
  47        else
  48                echo HEAD
  49        fi
  50}
  51
  52bisect_autostart() {
  53        test -s "$GIT_DIR/BISECT_START" || {
  54                gettextln "You need to start by \"git bisect start\"" >&2
  55                if test -t 0
  56                then
  57                        # TRANSLATORS: Make sure to include [Y] and [n] in your
  58                        # translation. The program will only accept English input
  59                        # at this point.
  60                        gettext "Do you want me to do it for you [Y/n]? " >&2
  61                        read yesno
  62                        case "$yesno" in
  63                        [Nn]*)
  64                                exit ;;
  65                        esac
  66                        bisect_start
  67                else
  68                        exit 1
  69                fi
  70        }
  71}
  72
  73bisect_start() {
  74        #
  75        # Check for one bad and then some good revisions.
  76        #
  77        has_double_dash=0
  78        for arg; do
  79                case "$arg" in --) has_double_dash=1; break ;; esac
  80        done
  81        orig_args=$(git rev-parse --sq-quote "$@")
  82        bad_seen=0
  83        eval=''
  84        must_write_terms=0
  85        revs=''
  86        if test "z$(git rev-parse --is-bare-repository)" != zfalse
  87        then
  88                mode=--no-checkout
  89        else
  90                mode=''
  91        fi
  92        while [ $# -gt 0 ]; do
  93                arg="$1"
  94                case "$arg" in
  95                --)
  96                        shift
  97                        break
  98                ;;
  99                --no-checkout)
 100                        mode=--no-checkout
 101                        shift ;;
 102                --term-good|--term-old)
 103                        shift
 104                        must_write_terms=1
 105                        TERM_GOOD=$1
 106                        shift ;;
 107                --term-good=*|--term-old=*)
 108                        must_write_terms=1
 109                        TERM_GOOD=${1#*=}
 110                        shift ;;
 111                --term-bad|--term-new)
 112                        shift
 113                        must_write_terms=1
 114                        TERM_BAD=$1
 115                        shift ;;
 116                --term-bad=*|--term-new=*)
 117                        must_write_terms=1
 118                        TERM_BAD=${1#*=}
 119                        shift ;;
 120                --*)
 121                        die "$(eval_gettext "unrecognised option: '\$arg'")" ;;
 122                *)
 123                        rev=$(git rev-parse -q --verify "$arg^{commit}") || {
 124                                test $has_double_dash -eq 1 &&
 125                                die "$(eval_gettext "'\$arg' does not appear to be a valid revision")"
 126                                break
 127                        }
 128                        revs="$revs $rev"
 129                        shift
 130                        ;;
 131                esac
 132        done
 133
 134        for rev in $revs
 135        do
 136                # The user ran "git bisect start <sha1>
 137                # <sha1>", hence did not explicitly specify
 138                # the terms, but we are already starting to
 139                # set references named with the default terms,
 140                # and won't be able to change afterwards.
 141                must_write_terms=1
 142
 143                case $bad_seen in
 144                0) state=$TERM_BAD ; bad_seen=1 ;;
 145                *) state=$TERM_GOOD ;;
 146                esac
 147                eval="$eval git bisect--helper --bisect-write '$state' '$rev' '$TERM_GOOD' '$TERM_BAD' 'nolog' &&"
 148        done
 149        #
 150        # Verify HEAD.
 151        #
 152        head=$(GIT_DIR="$GIT_DIR" git symbolic-ref -q HEAD) ||
 153        head=$(GIT_DIR="$GIT_DIR" git rev-parse --verify HEAD) ||
 154        die "$(gettext "Bad HEAD - I need a HEAD")"
 155
 156        #
 157        # Check if we are bisecting.
 158        #
 159        start_head=''
 160        if test -s "$GIT_DIR/BISECT_START"
 161        then
 162                # Reset to the rev from where we started.
 163                start_head=$(cat "$GIT_DIR/BISECT_START")
 164                if test "z$mode" != "z--no-checkout"
 165                then
 166                        git checkout "$start_head" -- ||
 167                        die "$(eval_gettext "Checking out '\$start_head' failed. Try 'git bisect reset <valid-branch>'.")"
 168                fi
 169        else
 170                # Get rev from where we start.
 171                case "$head" in
 172                refs/heads/*|$_x40)
 173                        # This error message should only be triggered by
 174                        # cogito usage, and cogito users should understand
 175                        # it relates to cg-seek.
 176                        [ -s "$GIT_DIR/head-name" ] &&
 177                                die "$(gettext "won't bisect on cg-seek'ed tree")"
 178                        start_head="${head#refs/heads/}"
 179                        ;;
 180                *)
 181                        die "$(gettext "Bad HEAD - strange symbolic ref")"
 182                        ;;
 183                esac
 184        fi
 185
 186        #
 187        # Get rid of any old bisect state.
 188        #
 189        git bisect--helper --bisect-clean-state || exit
 190
 191        #
 192        # Change state.
 193        # In case of mistaken revs or checkout error, or signals received,
 194        # "bisect_auto_next" below may exit or misbehave.
 195        # We have to trap this to be able to clean up using
 196        # "bisect_clean_state".
 197        #
 198        trap 'git bisect--helper --bisect-clean-state' 0
 199        trap 'exit 255' 1 2 3 15
 200
 201        #
 202        # Write new start state.
 203        #
 204        echo "$start_head" >"$GIT_DIR/BISECT_START" && {
 205                test "z$mode" != "z--no-checkout" ||
 206                git update-ref --no-deref BISECT_HEAD "$start_head"
 207        } &&
 208        git rev-parse --sq-quote "$@" >"$GIT_DIR/BISECT_NAMES" &&
 209        eval "$eval true" &&
 210        if test $must_write_terms -eq 1
 211        then
 212                git bisect--helper --write-terms "$TERM_BAD" "$TERM_GOOD" || exit
 213        fi &&
 214        echo "git bisect start$orig_args" >>"$GIT_DIR/BISECT_LOG" || exit
 215        #
 216        # Check if we can proceed to the next bisect state.
 217        #
 218        bisect_auto_next
 219
 220        trap '-' 0
 221}
 222
 223bisect_skip() {
 224        all=''
 225        for arg in "$@"
 226        do
 227                case "$arg" in
 228                *..*)
 229                        revs=$(git rev-list "$arg") || die "$(eval_gettext "Bad rev input: \$arg")" ;;
 230                *)
 231                        revs=$(git rev-parse --sq-quote "$arg") ;;
 232                esac
 233                all="$all $revs"
 234        done
 235        eval bisect_state 'skip' $all
 236}
 237
 238bisect_state() {
 239        bisect_autostart
 240        state=$1
 241        git bisect--helper --check-and-set-terms $state $TERM_GOOD $TERM_BAD || exit
 242        get_terms
 243        case "$#,$state" in
 244        0,*)
 245                die "Please call 'bisect_state' with at least one argument." ;;
 246        1,"$TERM_BAD"|1,"$TERM_GOOD"|1,skip)
 247                bisected_head=$(bisect_head)
 248                rev=$(git rev-parse --verify "$bisected_head") ||
 249                        die "$(eval_gettext "Bad rev input: \$bisected_head")"
 250                git bisect--helper --bisect-write "$state" "$rev" "$TERM_GOOD" "$TERM_BAD" || exit
 251                git bisect--helper --check-expected-revs "$rev" ;;
 252        2,"$TERM_BAD"|*,"$TERM_GOOD"|*,skip)
 253                shift
 254                hash_list=''
 255                for rev in "$@"
 256                do
 257                        sha=$(git rev-parse --verify "$rev^{commit}") ||
 258                                die "$(eval_gettext "Bad rev input: \$rev")"
 259                        hash_list="$hash_list $sha"
 260                done
 261                for rev in $hash_list
 262                do
 263                        git bisect--helper --bisect-write "$state" "$rev" "$TERM_GOOD" "$TERM_BAD" || exit
 264                done
 265                git bisect--helper --check-expected-revs $hash_list ;;
 266        *,"$TERM_BAD")
 267                die "$(eval_gettext "'git bisect \$TERM_BAD' can take only one argument.")" ;;
 268        *)
 269                usage ;;
 270        esac
 271        bisect_auto_next
 272}
 273
 274bisect_next_check() {
 275        missing_good= missing_bad=
 276        git show-ref -q --verify refs/bisect/$TERM_BAD || missing_bad=t
 277        test -n "$(git for-each-ref "refs/bisect/$TERM_GOOD-*")" || missing_good=t
 278
 279        case "$missing_good,$missing_bad,$1" in
 280        ,,*)
 281                : have both $TERM_GOOD and $TERM_BAD - ok
 282                ;;
 283        *,)
 284                # do not have both but not asked to fail - just report.
 285                false
 286                ;;
 287        t,,"$TERM_GOOD")
 288                # have bad (or new) but not good (or old).  we could bisect although
 289                # this is less optimum.
 290                eval_gettextln "Warning: bisecting only with a \$TERM_BAD commit." >&2
 291                if test -t 0
 292                then
 293                        # TRANSLATORS: Make sure to include [Y] and [n] in your
 294                        # translation. The program will only accept English input
 295                        # at this point.
 296                        gettext "Are you sure [Y/n]? " >&2
 297                        read yesno
 298                        case "$yesno" in [Nn]*) exit 1 ;; esac
 299                fi
 300                : bisect without $TERM_GOOD...
 301                ;;
 302        *)
 303                bad_syn=$(bisect_voc bad)
 304                good_syn=$(bisect_voc good)
 305                if test -s "$GIT_DIR/BISECT_START"
 306                then
 307
 308                        eval_gettextln "You need to give me at least one \$bad_syn and one \$good_syn revision.
 309(You can use \"git bisect \$bad_syn\" and \"git bisect \$good_syn\" for that.)" >&2
 310                else
 311                        eval_gettextln "You need to start by \"git bisect start\".
 312You then need to give me at least one \$good_syn and one \$bad_syn revision.
 313(You can use \"git bisect \$bad_syn\" and \"git bisect \$good_syn\" for that.)" >&2
 314                fi
 315                exit 1 ;;
 316        esac
 317}
 318
 319bisect_auto_next() {
 320        bisect_next_check && bisect_next || :
 321}
 322
 323bisect_next() {
 324        case "$#" in 0) ;; *) usage ;; esac
 325        bisect_autostart
 326        bisect_next_check $TERM_GOOD
 327
 328        # Perform all bisection computation, display and checkout
 329        git bisect--helper --next-all $(test -f "$GIT_DIR/BISECT_HEAD" && echo --no-checkout)
 330        res=$?
 331
 332        # Check if we should exit because bisection is finished
 333        if test $res -eq 10
 334        then
 335                bad_rev=$(git show-ref --hash --verify refs/bisect/$TERM_BAD)
 336                bad_commit=$(git show-branch $bad_rev)
 337                echo "# first $TERM_BAD commit: $bad_commit" >>"$GIT_DIR/BISECT_LOG"
 338                exit 0
 339        elif test $res -eq 2
 340        then
 341                echo "# only skipped commits left to test" >>"$GIT_DIR/BISECT_LOG"
 342                good_revs=$(git for-each-ref --format="%(objectname)" "refs/bisect/$TERM_GOOD-*")
 343                for skipped in $(git rev-list refs/bisect/$TERM_BAD --not $good_revs)
 344                do
 345                        skipped_commit=$(git show-branch $skipped)
 346                        echo "# possible first $TERM_BAD commit: $skipped_commit" >>"$GIT_DIR/BISECT_LOG"
 347                done
 348                exit $res
 349        fi
 350
 351        # Check for an error in the bisection process
 352        test $res -ne 0 && exit $res
 353
 354        return 0
 355}
 356
 357bisect_visualize() {
 358        bisect_next_check fail
 359
 360        if test $# = 0
 361        then
 362                if test -n "${DISPLAY+set}${SESSIONNAME+set}${MSYSTEM+set}${SECURITYSESSIONID+set}" &&
 363                        type gitk >/dev/null 2>&1
 364                then
 365                        set gitk
 366                else
 367                        set git log
 368                fi
 369        else
 370                case "$1" in
 371                git*|tig) ;;
 372                -*)     set git log "$@" ;;
 373                *)      set git "$@" ;;
 374                esac
 375        fi
 376
 377        eval '"$@"' --bisect -- $(cat "$GIT_DIR/BISECT_NAMES")
 378}
 379
 380bisect_replay () {
 381        file="$1"
 382        test "$#" -eq 1 || die "$(gettext "No logfile given")"
 383        test -r "$file" || die "$(eval_gettext "cannot read \$file for replaying")"
 384        git bisect--helper --bisect-reset || exit
 385        while read git bisect command rev
 386        do
 387                test "$git $bisect" = "git bisect" || test "$git" = "git-bisect" || continue
 388                if test "$git" = "git-bisect"
 389                then
 390                        rev="$command"
 391                        command="$bisect"
 392                fi
 393                get_terms
 394                git bisect--helper --check-and-set-terms "$command" "$TERM_GOOD" "$TERM_BAD" || exit
 395                get_terms
 396                case "$command" in
 397                start)
 398                        cmd="bisect_start $rev"
 399                        eval "$cmd" ;;
 400                "$TERM_GOOD"|"$TERM_BAD"|skip)
 401                        git bisect--helper --bisect-write "$command" "$rev" "$TERM_GOOD" "$TERM_BAD" || exit;;
 402                terms)
 403                        bisect_terms $rev ;;
 404                *)
 405                        die "$(gettext "?? what are you talking about?")" ;;
 406                esac
 407        done <"$file"
 408        bisect_auto_next
 409}
 410
 411bisect_run () {
 412        bisect_next_check fail
 413
 414        test -n "$*" || die "$(gettext "bisect run failed: no command provided.")"
 415
 416        while true
 417        do
 418                command="$@"
 419                eval_gettextln "running \$command"
 420                "$@"
 421                res=$?
 422
 423                # Check for really bad run error.
 424                if [ $res -lt 0 -o $res -ge 128 ]
 425                then
 426                        eval_gettextln "bisect run failed:
 427exit code \$res from '\$command' is < 0 or >= 128" >&2
 428                        exit $res
 429                fi
 430
 431                # Find current state depending on run success or failure.
 432                # A special exit code of 125 means cannot test.
 433                if [ $res -eq 125 ]
 434                then
 435                        state='skip'
 436                elif [ $res -gt 0 ]
 437                then
 438                        state="$TERM_BAD"
 439                else
 440                        state="$TERM_GOOD"
 441                fi
 442
 443                # We have to use a subshell because "bisect_state" can exit.
 444                ( bisect_state $state >"$GIT_DIR/BISECT_RUN" )
 445                res=$?
 446
 447                cat "$GIT_DIR/BISECT_RUN"
 448
 449                if sane_grep "first $TERM_BAD commit could be any of" "$GIT_DIR/BISECT_RUN" \
 450                        >/dev/null
 451                then
 452                        gettextln "bisect run cannot continue any more" >&2
 453                        exit $res
 454                fi
 455
 456                if [ $res -ne 0 ]
 457                then
 458                        eval_gettextln "bisect run failed:
 459'bisect_state \$state' exited with error code \$res" >&2
 460                        exit $res
 461                fi
 462
 463                if sane_grep "is the first $TERM_BAD commit" "$GIT_DIR/BISECT_RUN" >/dev/null
 464                then
 465                        gettextln "bisect run success"
 466                        exit 0;
 467                fi
 468
 469        done
 470}
 471
 472bisect_log () {
 473        test -s "$GIT_DIR/BISECT_LOG" || die "$(gettext "We are not bisecting.")"
 474        cat "$GIT_DIR/BISECT_LOG"
 475}
 476
 477get_terms () {
 478        if test -s "$GIT_DIR/BISECT_TERMS"
 479        then
 480                {
 481                read TERM_BAD
 482                read TERM_GOOD
 483                } <"$GIT_DIR/BISECT_TERMS"
 484        fi
 485}
 486
 487bisect_voc () {
 488        case "$1" in
 489        bad) echo "bad|new" ;;
 490        good) echo "good|old" ;;
 491        esac
 492}
 493
 494bisect_terms () {
 495        get_terms
 496        if ! test -s "$GIT_DIR/BISECT_TERMS"
 497        then
 498                die "$(gettext "no terms defined")"
 499        fi
 500        case "$#" in
 501        0)
 502                gettextln "Your current terms are $TERM_GOOD for the old state
 503and $TERM_BAD for the new state."
 504                ;;
 505        1)
 506                arg=$1
 507                case "$arg" in
 508                        --term-good|--term-old)
 509                                printf '%s\n' "$TERM_GOOD"
 510                                ;;
 511                        --term-bad|--term-new)
 512                                printf '%s\n' "$TERM_BAD"
 513                                ;;
 514                        *)
 515                                die "$(eval_gettext "invalid argument \$arg for 'git bisect terms'.
 516Supported options are: --term-good|--term-old and --term-bad|--term-new.")"
 517                                ;;
 518                esac
 519                ;;
 520        *)
 521                usage ;;
 522        esac
 523}
 524
 525case "$#" in
 5260)
 527        usage ;;
 528*)
 529        cmd="$1"
 530        get_terms
 531        shift
 532        case "$cmd" in
 533        help)
 534                git bisect -h ;;
 535        start)
 536                bisect_start "$@" ;;
 537        bad|good|new|old|"$TERM_BAD"|"$TERM_GOOD")
 538                bisect_state "$cmd" "$@" ;;
 539        skip)
 540                bisect_skip "$@" ;;
 541        next)
 542                # Not sure we want "next" at the UI level anymore.
 543                bisect_next "$@" ;;
 544        visualize|view)
 545                bisect_visualize "$@" ;;
 546        reset)
 547                git bisect--helper --bisect-reset "$@" ;;
 548        replay)
 549                bisect_replay "$@" ;;
 550        log)
 551                bisect_log ;;
 552        run)
 553                bisect_run "$@" ;;
 554        terms)
 555                bisect_terms "$@" ;;
 556        *)
 557                usage ;;
 558        esac
 559esac